<div class="main-content" (window:resize)="onResize($event)" id='myDashboard' [ngClass]="{'noSidebar': display_v.panelMode }">
    <!-- ============================================================== -->
    <!-- TITLE  -->
    <!-- ============================================================== -->
    <div class="col-12" style="padding:2px"  *ngIf="!display_v.panelMode">
        <eda-dashboard-panel class="pointer" (click)="setTitle()">
            <div class="d-flex justify-title-content">
                <h3 *ngIf="!titleClick" class="eda-title"> {{title}} </h3>
                <input *ngIf="!!titleClick" (focusout)="setTitle()" (keydown.enter)="setTitle()" type="text" class="w-100" [(ngModel)]="title" pInputText autofocusOnShow>
            </div>
        </eda-dashboard-panel>
    </div>


    <!-- ============================================================== -->
    <!-- GLOBAL FILTERS  -->
    <!-- ============================================================== -->
    <div [ngClass]="{'noShow': display_v.panelMode }" > <!--   panel mode es per quan vull mostrat nomes un panell-->
    <div *ngIf="filtersList.length > 0" class="d-flex align-items-end" style="margin: 0.5em; gap: 10px; flex-wrap: wrap;" >
        
        
        <button
            *ngIf="userService.isAdmin || filterButtonVisibility.public || isDashboardCreator"
            id="dashFilterBtn"
            [label]="filtrar"
            pButton pRipple type="button"
            icon="pi pi-filter"
            style="height: 36px; min-width: 80px;"
            (click)="reloadPanelsWithTimeOut()"
            class="p-button-raised p-button-outlined filters-size">
        </button>

       

        <div *ngFor="let filter of filtersList" class="filter-set d-flex align-items-center">
            <span *ngIf="userService.isAdmin || filter.visible === 'public' || filter.visible === 'readOnly' || isDashboardCreator" class="filter-name filters-size"> {{filter.column.label}}: </span>
            <p-multiSelect *ngIf="filter.data && filter.column.value.column_type !== 'date'  && (userService.isAdmin || filter.visible == 'public' || isDashboardCreator) "
                [options]="filter.data"
                [(ngModel)]="filter.selectedItems"
                [virtualScroll]="true"
                itemSize="30"
                [maxSelectedLabels]="3"
                defaultLabel="{{filter.column.label}}"
                display="chip"
                class="customMultiselect filters-size"
                [style]="{'max-width': '250px', 'min-width':'200px', 'font-family':'var(--eda-filters-font-family)'}"
                [Show]="adjustSize(filter)"
                (onChange)="applyGlobalFilter(filter)">

                <p-footer>
                    <button *ngIf="canIedit()" id="dashFilterConf"
                        pButton pRipple type="button"
                        icon="pi pi-cog"
                        (click)="onFilterConfig(false, filter)"
                        class="p-button-rounded p-button-outlined filters-size">
                    </button>

                    <button *ngIf="autoClear"
                        pButton pRipple type="button"
                        icon="pi pi-undo"
                        (click)="clearRangeDates();emitChanges();"
                        class="p-button-rounded p-button-outlined">
                    </button>
                </p-footer>
            </p-multiSelect>

            <p-multiSelect *ngIf="filter.data && filter.column.value.column_type !== 'date'  && (!userService.isAdmin && filter.visible === 'readOnly' && !isDashboardCreator)"
                [options]="filter.data"
                [(ngModel)]="filter.selectedItems"
                [virtualScroll]="true"
                itemSize="30"
                [maxSelectedLabels]="3"
                defaultLabel="{{filter.column.label}}"
                display="chip"
                disabled="true"
                class="customMultiselect filters-size"
                [style]="{'max-width': '250px', 'min-width':'200px', 'font-family':'var(--eda-filters-font-family)'}"
                [Show]="adjustSize(filter)"
                (onChange)="applyGlobalFilter(filter)">

                <p-footer>
                    <button id="dashFilterConf"
                        pButton pRipple type="button"
                        icon="pi pi-cog"
                        (click)="onFilterConfig(false, filter)"
                        class="p-button-rounded p-button-outlined filters-size">
                    </button>

                    <button *ngIf="autoClear"
                        pButton pRipple type="button"
                        icon="pi pi-undo"
                        (click)="clearRangeDates();emitChanges();"
                        class="p-button-rounded p-button-outlined">
                    </button>
                </p-footer>
            </p-multiSelect>

            <eda-date-picker
                *ngIf="filter.column.value.column_type === 'date' && (filter.visible === 'public' || userService.isAdmin || isDashboardCreator) "
                [autoClear]="true"
                [inject]="datePickerConfigs[filter.id]"
                (onRemove)="removeGlobalFilter(filter, true)"
                (onDatesChanges)="processPickerEvent($event, filter)">

                <ng-container footer>
                    <button id="dashFilterConf"
                        pButton pRipple type="button"
                        icon="pi pi-cog"
                        (click)="onFilterConfig(false, filter)"
                        class="p-button-rounded p-button-outlined filters-size">
                    </button>
                </ng-container>
            </eda-date-picker>
        </div>
    </div>
    </div>

    <ngx-gridster class="dashboard-grid" [options]="gridsterOptions" [draggableOptions]="gridsterDraggableOptions" #gridster1 >
        <!-- Normal Size -->
        <ng-container *ngIf="!toLitle && !toMedium" >
            <ngx-gridster-item *ngFor="let panel of panels"  [options]="itemOptions" [dragAndDrop]="true" [resizable]="panel.resizable" [(w)]="panel.w" [(h)]="panel.h" [(x)]="panel.x" [(y)]="panel.y" (change)="itemChange($event, panel)">
                <ng-container *ngTemplateOutlet="panelTemplate; context: {$implicit: panel}"></ng-container>
            </ngx-gridster-item>
        </ng-container>

        <!-- Mid  Size -->
        <ng-container *ngIf="toMedium">
            <ngx-gridster-item *ngFor="let panel of panels" [options]="itemOptions" [dragAndDrop]="panel.dragAndDrop" [resizable]="panel.resizable" [(w)]="panel.tamanyMig.w" [(h)]="panel.tamanyMig.h" [(x)]="panel.tamanyMig.x" [(y)]="panel.tamanyMig.y" (change)="itemChange($event, panel)">
                <ng-container *ngTemplateOutlet="panelTemplate; context: {$implicit: panel}"></ng-container>
            </ngx-gridster-item>
        </ng-container>

        <!-- Mobile Size -->
        <ng-container *ngIf="toLitle">
            <ngx-gridster-item *ngFor="let panel of panels" [options]="itemOptions" [dragAndDrop]="panel.dragAndDrop" [resizable]="panel.resizable" [(w)]="panel.tamanyMobil.w" [(h)]="panel.tamanyMobil.h" [(x)]="panel.tamanyMobil.x" [(y)]="panel.tamanyMobil.y" (change)="itemChange($event, panel)">
                <ng-container *ngTemplateOutlet="panelTemplate; context: {$implicit: panel}"></ng-container>
            </ngx-gridster-item>
        </ng-container>

    </ngx-gridster>

    <ng-template #panelTemplate let-panel>
        <ng-container [ngSwitch]="panel.type">

            <eda-blank-panel *ngSwitchCase="0" #edaPanel [panel]="panel" [inject]="inject" (remove)="onRemovePanel($event)" (action)="onPanelAction($event)" (duplicate)="onDuplicatePanel($event)" >
            </eda-blank-panel>

            <eda-title-panel *ngSwitchCase="1" #edaPanel [id]="panel.id" [panel]="panel" [inject]="inject" (remove)="onRemovePanel($event)" (duplicate)="onDuplicatePanel($event)" class="eda-text-panel">
            </eda-title-panel>

        </ng-container>
    </ng-template>

</div>

<!-- ============================================================== -->
<!-- GLOBAL FILTERS PANEL -->
<!-- ============================================================== -->
<dashboard-filter-dialog *ngIf="filterController" [controller]="filterController"></dashboard-filter-dialog>

<!-- ============================================================== -->
<!-- SENT VIA EMAIL PANEL -->
<!-- ============================================================== -->
<dashboard-mail-dialog *ngIf="emailController" [controller]="emailController"></dashboard-mail-dialog>

<!-- ============================================================== -->
<!-- SAVE AS PANEL -->
<!-- ============================================================== -->
<save-as-dialog *ngIf="saveasController" [controller]="saveasController"></save-as-dialog>


<!-- ============================================================== -->
<!-- EDIT STYLES -->
<!-- ============================================================== -->
<edit-styles-dialog *ngIf="editStylesController" [controller]="editStylesController"></edit-styles-dialog>

<!-- ============================================================== -->
<!-- Right sidebar -->
<!-- ============================================================== -->
<p-sidebar [(visible)]="display_v.rightSidebar"
            position="right"
            [baseZIndex]="10000"
            blockScroll="true"
            [showCloseIcon]="false"
            [style]="{width:'25em', overflow: 'auto'}"  >

    <div>

        <div class="right-sidebar-blocks-title  mt-1">
            <span class="ml-2">{{datasourceName}}</span>
        </div>

    </div>
    <hr>

    <div *ngIf="display_v.edit_mode" class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="onAddWidget()">
        <div>
            <i id="newPanel" class="fa fa-columns"></i>
            <span i18n="@@opcionPanel" class="ml-2">NUEVO PANEL</span>
        </div>
    </div>

    <div *ngIf="display_v.edit_mode" class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="onAddTitle()">
        <div>
            <i class="fa fa-columns"></i>
            <span i18n="@@opcionTitulo" class="ml-2">NUEVO TEXTO</span>
        </div>
    </div>

    <div *ngIf="display_v.edit_mode" class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="addGlobalFilter()">
        <div>
            <i id="newFilter" class="fa fa-filter"></i>
            <span i18n="@@opcionFiltro" class="ml-2">NUEVO FILTRO</span>
        </div>
    </div>

    <hr>

    <div class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="onResetWidgets()">
        <div>
            <i class="fa fa-ban"></i>
            <span i18n="@@opcionInforme" class="ml-2">RECARGAR INFORME</span>
        </div>
    </div>

    <div *ngIf="display_v.edit_mode" class="right-sidebar-blocks-options block-options-bg pointer mt-1">
        <div>
            <div>
                <i class="fa fa-tag" ></i>
                <span class="ml-2"> {{addTagString}} </span>
            </div>
            <div>
                <p-multiSelect class="ml-2" [options]="tags"  [(ngModel)]="selectedTags" [placeholder]="addTagString" showHeader="false" maxSelectedLabels="0" selectedItemsLabel="Show tags"></p-multiSelect>
            </div>
            <br>
            <div>
                 <button pButton pRipple type="button" *ngIf="!addTag" class="p-button-raised p-button-success ml-2" (click)="addNewTag()" style="background-color: #4CAF50">
                    <span i18n="@@newTag"> Nueva etiqueta </span>
                 </button>
            </div>
            <input class="ml-2" *ngIf="addTag" type="text" pInputText [(ngModel)]="applyNewTag"> 
            <button pButton pRipple type="button" *ngIf="addTag" class="p-button-raised p-button-success ml-2" style="background-color: #4CAF50" (click)="setNewTag(applyNewTag)">
                <span> Confirmar </span>
            </button>
        </div>
    </div>

    <div *ngIf="display_v.edit_mode" class="right-sidebar-blocks-options block-options-bg pointer mt-1">
        <div>
            <span class="ml-2">LIVE DASHBOARD</span>
            <input style="width: 100%; margin-top: 0.2rem;" [placeholder]="Seconds_to_refresh" type="number" pInputText [(ngModel)]="refreshTime">
        </div>
    </div>


    <hr>
    <div *ngIf="display_v.edit_mode && canIedit()" class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="saveDashboard()">
        <div>
            <i id="saveDashboard" class="fa fa-save"></i>
            <span i18n="@@opcionGuardar" class="ml-2">GUARDAR</span>
        </div>
    </div>
    <div *ngIf="display_v.edit_mode" class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="saveAs()">
        <div>
            <i id="saveDashboard" class="fa fa-save"></i>
            <span i18n="@@opcionGuardarComo" class="ml-2">GUARDAR COMO</span>
        </div>
    </div>

    <div *ngIf="display_v.edit_mode">
        <form [formGroup]="form" *ngIf="canIedit()" >
            <div class="ml-3">
                <p-selectButton [options]="visibleTypes" formControlName="visible" (onChange)="handleSelectedBtn($event)">
                </p-selectButton>


            </div>
            <div  *ngIf="display_v.groups" class="ml-3">
                <br>
                <p-multiSelect id="float-grups" formControlName="group" [options]="grups" [filter]="true"
                 optionLabel="name" defaultLabel="Elige grupos *" [style]="{ width: '100%' }" itemSize="30" overflow="visible"
                 >
                </p-multiSelect>
            </div>
        </form>
        <button id="copy-link" (click)="copyURL()" *ngIf="display_v.shared">
            <span>
                <i class="fa fa-files-o" aria-hidden="true"></i>
                copiar URL pública
            </span>
        </button>
    </div>

    <div *ngIf="display_v.edit_mode && canIedit()"  [pTooltip]="canIeditTooltip" tooltipPosition="above" class="canIeditClass ml-3">
        <div i18n="@@onlyIcanEditTag" class="canIeditClassLabel"  >
            Edición privada:
        </div>
        <div class="canIeditClassLabel"  [pTooltip]="canIeditTooltip" tooltipPosition="above"  >
            <p-inputSwitch id="onlyIcanEdit" class="col-1 sql-switch" [(ngModel)]="onlyIcanEdit"
            tooltipPosition="top"   >
            </p-inputSwitch>
        </div>
    </div>

    <hr>
    <div *ngIf="display_v.edit_mode" class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="editStyles()">
        <div>
            <i class="fa fa-paint-brush"></i>
            <span i18n="@@opcionEditarEstilos" class="ml-2">EDITAR ESTILOS</span>
        </div>
    </div>

    <div class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="exportAsPDF();">
        <div>
            <i class="fa fa-download"></i>
            <span i18n="@@opcionPdf" class="ml-2">DESCARGAR PDF</span>
        </div>
    </div>

    <div class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="exportAsJPEG();">
        <div>
            <i class="fa fa-download"></i>
            <span i18n="@@opcionImagen" class="ml-2">DESCARGAR IMAGEN</span>
        </div>
    </div>

    <div  *ngIf="display_v.edit_mode && canIedit()" class="right-sidebar-blocks-options block-options-bg pointer mt-1" (click)="openMailConfig();">
        <div>
            <i class="fa fa-envelope-o"></i>
            <span i18n="@@opcionMail" class="ml-2">ENVIAR POR EMAIL</span>
        </div>
    </div>



</p-sidebar>

<div>
    <span i18n="@@notSavedChanges" class="div-cambios " *ngIf="display_v.notSaved" style="color: var(--panel-font-color);"> Hay cambios sin guardar... </span>

    <button *ngIf="!display_v.hideWheel" (click)="display_v.rightSidebar = true" class="right-side-toggle waves-effect waves-light btn-inverse btn btn-circle btn-sm pull-right m-l-10">
        <i id="gearButton" class="fa fa-cog text-white" style="font-size: 14px;"></i>
    </button>

</div>


<div  *ngIf="display_v.panelMode" >
  <a href="https://eda.jortilles.com/">Enterprise Data Analytics</a>
</div>
